/*
 * $TSUKUBA_Release: Omni OpenMP/XcalableMP Compiler Software Version 0.5.1 $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  * The specification of XcalableMP has been designed by the XcalableMP
 *    Specification Working Group (http://www.xcalablemp.org/).
 *  
 *  * The development of this software is supported by "Seamless and
 *    Highly-productive Parallel Programming Environment for
 *    High-performance computing" project funded by Ministry of Education,
 *    Culture, Sports, Science and Technology, Japan.
 *  $
 */

#include "mpi.h"
#include "xmp_internal.h"

// FIXME utility functions
void xmp_get_comm(void **comm) {
  *comm = _XMP_get_execution_nodes()->comm;
}

int xmp_get_size(void) {
  return _XMP_get_execution_nodes()->comm_size;
}

int xmp_get_rank(void) {
  return _XMP_get_execution_nodes()->comm_rank;
}

void xmp_barrier(void) {
  _XMP_barrier_EXEC();
}

int xmp_get_world_size(void) {
  return _XMP_world_size;
}

int xmp_get_world_rank(void) {
  return _XMP_world_rank;
}

double xmp_wtime(void) {
  return MPI_Wtime();
}
